package org.objectweb.modfact.jmi.ps;

import javax.jmi.reflect.*;
import java.util.*;


/**
 * @author gregory
 * Test memory load in a basic way !
 * not stable !!!
 */
public class  TestMemoryLoad{

	public static void main(String[] args) throws Exception {

		PersistantService pms = new PersistantService();
		
		Vector p = new Vector();
		RefPackage p2, p3, p4 = null;
		int maxModels = 10;

		PersistantHelper.printFreeMemory("before programm");


//				RefPackage p;
//				XmiReader reader = new XmiReader_impl();
//				p = RefPackage_impl.getM2Repository();
//				
//				reader.read("file:///C:/Documents and Settings/gregory/Bureau/Doc/Metamodels/samples/samples/simpleTRL.xml",p);

		
		
		PersistantHelper ph = new PersistantHelper();

		//reading one meta model
		 pms.load("THEXMLMODEL");
		PersistantHelper.printFreeMemory("after loadind the XML etamodel");

		//reading many metamodels
		for (int i = 0; i < maxModels; i++) {
			pms.load("SIMPLE_TRL");
			PersistantHelper.printFreeMemory("after loadind the SIMPLE TRL metamodel " + i);
		}

		//writing the SIMPLE TRL metamodels
		for (int i = 0; i < maxModels; i++) {

			pms.store("SIMPLE_TRL");
			PersistantHelper.printFreeMemory("after writing the metamodel SIMPLE TRL " + i);
		}
		
		//writing the XML metamodel
		pms.store( "THEXMLMODE");
		PersistantHelper.printFreeMemory("after writing the metamodel XML MODEL");

	}
}
