package org.objectweb.modfact.jmi.xmi;

import javax.jmi.reflect.*;
import javax.jmi.xmi.*;
import java.io.*;
import java.util.*;

public class XmiWriterImpl implements XmiWriter {
        
	boolean useFullyQualifiedName = false;
    
    public XmiWriterImpl() {
    }
    
    public void write(OutputStream out, Collection objs, String version) throws IOException {
      Writer w = new Writer(this, out);
      w.writeHeader();
      Iterator it = objs.iterator();
      while(it.hasNext()) {
        RefObject o = (RefObject) it.next();
        w.writeOuterMostCompositeOf(o);             
      }
      w.writeReferencedObjects();
      w.writeEnd();
    }
    
    
    public void write(OutputStream out, RefPackage extent, String version) throws IOException {
      Writer w = new Writer(this, out);
      w.writeHeader();
	  w.writePackage(extent);
	  w.writeReferencedObjects();	  
      w.writeEnd();
    } 
    
    

     
}
