// $ANTLR : "S.g" -> "STRLParser.java"$
package org.objectweb.modfact.qvt.syntaxe;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import java.util.*;
import java.util.logging.Logger;
public class STRLParser extends antlr.LLkParser       implements STRLParserTokenTypes
 {
Vector ValAssExpVec, RuleElemVec; 	// Vecteur contenant tous les lments d'un Statement																  *	
Vector ifVect=new Vector();       	// Vecteur pour grer l'imbrication des IfStatement																	  *
Vector ifElse=new Vector();	  	// Vecteur pour grer l'imbrication des Statements si dans le block if/else                                           *
Hashtable RulesTab;				  	// Une Table de Hash pour recenser toutes le rgles et viter d'en crer deux fois la mme rgle; Key=nom de la rgle *
String CurrentRule=null;			// Permet de savoir la rgle courante au moment de rajouter le Statement											  *	
simpletrl.RulesUnit unit;			   // Permet de rajouter une rgle  Rules Unit n'importe o dans le programme										  *
simpletrl.PropertyAssignExp pAssExp;   // manipule par plusieurs blocks																				  *
simpletrl.IfStatementExp iFSE;		   // manipule par plusieurs blocks 																				  *
simpletrl.SimpleTRLPackage rulesModel; // Le modle simpleTRL en question																				  *	
private Logger logger;				   // Pour la Trace															  										  *
//*LES METHODES GET & SET LOGGER POUR LA TRACE*************************************************************************************************************

public void setRuleModel(simpletrl.SimpleTRLPackage rulesModel) {
		this.rulesModel = rulesModel;
	}

public Logger getLogger() {
		return logger;
	}

public void setLogger(Logger logger) {
		this.logger = logger;
	}	

protected STRLParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public STRLParser(TokenBuffer tokenBuf) {
  this(tokenBuf,3);
}

protected STRLParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public STRLParser(TokenStream lexer) {
  this(lexer,3);
}

public STRLParser(ParserSharedInputState state) {
  super(state,3);
  tokenNames = _tokenNames;
}

	public final void file() throws RecognitionException, TokenStreamException {
		
		Token  n = null;
		Token  s = null;
		Token  t = null;
		logger.fine("File Rule Called");
							  RulesTab=new Hashtable();
							
		
		try {      // for error handling
			{
			match(LITERAL_RulesUnit);
			{
			int _cnt260=0;
			_loop260:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt260>=1 ) { break _loop260; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt260++;
			} while (true);
			}
			n = LT(1);
			match(NAME);
			{
			int _cnt262=0;
			_loop262:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt262>=1 ) { break _loop262; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt262++;
			} while (true);
			}
			match(SOURCE);
			{
			int _cnt264=0;
			_loop264:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt264>=1 ) { break _loop264; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt264++;
			} while (true);
			}
			s = LT(1);
			match(NAME);
			{
			int _cnt266=0;
			_loop266:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt266>=1 ) { break _loop266; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt266++;
			} while (true);
			}
			match(TARGET);
			{
			int _cnt268=0;
			_loop268:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt268>=1 ) { break _loop268; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt268++;
			} while (true);
			}
			t = LT(1);
			match(NAME);
			{
			int _cnt270=0;
			_loop270:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt270>=1 ) { break _loop270; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt270++;
			} while (true);
			}
			match(OPENBRACKET);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case WS:
			case LITERAL_EntryPointRule:
			case LITERAL_Rule:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			unit = rulesModel.getRulesUnit().createRulesUnit(n.getText(),s.getText(),t.getText());
			{
			_loop273:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop273;
				}
				
			} while (true);
			}
			{
			int _cnt275=0;
			_loop275:
			do {
				if ((LA(1)==LITERAL_EntryPointRule||LA(1)==LITERAL_Rule)) {
					rule();
					match(NEWLINE);
				}
				else {
					if ( _cnt275>=1 ) { break _loop275; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt275++;
			} while (true);
			}
			match(CLOSEBRACKET);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case EOF:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			}
			logger.fine("name =" + n.getText());
							 	 logger.fine("Source =" + s.getText());
							 	 logger.fine("Target =" + t.getText());
							 	 logger.fine("Recognition Succed");
							 	
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
	}
	
	public final void rule() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_EntryPointRule:
			{
				erp();
				break;
			}
			case LITERAL_Rule:
			{
				cr();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			logger.fine("rule");
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
	}
	
	public final void erp() throws RecognitionException, TokenStreamException {
		
		Token  n = null;
		Token  elementcontext = null;
		String resultElement=null; simpletrl.EntryPointRule epr;
		
		try {      // for error handling
			{
			match(LITERAL_EntryPointRule);
			{
			int _cnt282=0;
			_loop282:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt282>=1 ) { break _loop282; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt282++;
			} while (true);
			}
			n = LT(1);
			match(NAME);
			match(NEWLINE);
			{
			_loop284:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop284;
				}
				
			} while (true);
			}
			match(LITERAL_context);
			{
			int _cnt286=0;
			_loop286:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt286>=1 ) { break _loop286; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt286++;
			} while (true);
			}
			elementcontext = LT(1);
			match(NAME);
			match(NEWLINE);
			{
			switch ( LA(1)) {
			case LITERAL_creates:
			{
				resultElement=createclose();
				break;
			}
			case WS:
			case NEWLINE:
			case OPENCROCHET:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			logger.fine("EntryPointRule Called");			 
								 epr = rulesModel.getEntryPointRule().createEntryPointRule(n.getText(),"","",elementcontext.getText());
								 
								 // Correspond  l'attribut resultType dans le MM SimpleTRL 
								 if (resultElement!=null)
									 epr.setResultType(resultElement);
								 else
								     epr.setResultType("");
								 // La fixer comme la rgle courante
								 CurrentRule=n.getText();
								 // Rajouter la rgle dans tables des rgles
								 RulesTab.put(n.getText(),epr);
								
			{
			_loop289:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop289;
				}
				
			} while (true);
			}
			{
			switch ( LA(1)) {
			case OPENCROCHET:
			{
				body();
				break;
			}
			case NEWLINE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
	}
	
	public final void cr() throws RecognitionException, TokenStreamException {
		
		Token  n = null;
		simpletrl.CalledRule cr=null; simpletrl.ValueExp vExp=null; 
							  String resultElement=null; java.util.Vector Parameters=new java.util.Vector(); boolean exist=true;
							
		
		try {      // for error handling
			{
			match(LITERAL_Rule);
			{
			int _cnt294=0;
			_loop294:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt294>=1 ) { break _loop294; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt294++;
			} while (true);
			}
			n = LT(1);
			match(NAME);
			{
			Parameters=signRule();
			}
			exist=(RulesTab.containsKey(n.getText()));
								  CurrentRule=n.getText(); 
								
			match(NEWLINE);
			{
			_loop297:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop297;
				}
				
			} while (true);
			}
			{
			switch ( LA(1)) {
			case LITERAL_creates:
			{
				resultElement=createclose();
				break;
			}
			case NEWLINE:
			case OPENCROCHET:
			case LITERAL_return:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_return:
			{
				vExp=returnclose();
				break;
			}
			case NEWLINE:
			case OPENCROCHET:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			logger.fine("CalledRule  Called");
			
								 //Vrifier si la rgle n'existe pas dj
								 if (!(exist)){
								 	cr=rulesModel.getCalledRule().createCalledRule();
								 	cr.setName(n.getText());
								 	
								 	if (resultElement!=null)
										 cr.setResultType(resultElement);
								 	else
								    	 cr.setResultType("");
								 	// Fixation des paramtres de la rgle
								 	for (int i=0; i<Parameters.size(); i++){
								    	 simpletrl.ParameterExp Param=rulesModel.getParameterExp().createParameterExp(((simpletrl.ParameterExp)Parameters.elementAt(i)).getName());
								   	 	 cr.getParams().add(Param);
								   	} 
								   	
								   	if (vExp!=null)
								   		cr.setReturnVal(vExp);
			
								   	RulesTab.put(cr.getName(),cr);
								
								 }
								 else{
								 	cr=((simpletrl.CalledRule)RulesTab.get(n.getText()));
								 	
								 	if (resultElement!=null)
										 cr.setResultType(resultElement);
								 	else
								    	 cr.setResultType("");
								 
								 	for (int i=0; i<Parameters.size(); i++){
								    	 simpletrl.ParameterExp Param=rulesModel.getParameterExp().createParameterExp(((simpletrl.ParameterExp)Parameters.elementAt(i)).getName());
								   	 	 cr.getParams().add(Param);
								   	}
								 	if (vExp!=null)
								   		cr.setReturnVal(vExp);
								 	
								 }
								 
								 logger.fine("CR Position, la Rgle courante est :" + CurrentRule);	 			 
								
			{
			switch ( LA(1)) {
			case OPENCROCHET:
			{
				body();
				break;
			}
			case NEWLINE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
	}
	
	public final String  createclose() throws RecognitionException, TokenStreamException {
		String resultElement= new String();
		
		Token  n = null;
		
		try {      // for error handling
			match(LITERAL_creates);
			{
			int _cnt324=0;
			_loop324:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt324>=1 ) { break _loop324; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt324++;
			} while (true);
			}
			n = LT(1);
			match(NAME);
			match(NEWLINE);
			resultElement=n.getText();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		return resultElement;
	}
	
	public final void body() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			match(OPENCROCHET);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case WS:
			case NAME:
			case CLOSECROCHET:
			case DIEZ:
			case POINTEXCLAM:
			case POINT:
			case LITERAL_allOfType:
			case LITERAL_add:
			case LITERAL_remove:
			case LITERAL_isOfType:
			case LITERAL_equals:
			case INTERO:
			case LITERAL_if:
			case BOOLEAN:
			case INTEGER:
			case DOUBLE:
			case LITERAL_enum:
			case GUILL:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop304:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop304;
				}
				
			} while (true);
			}
			{
			_loop306:
			do {
				if ((_tokenSet_3.member(LA(1)))) {
					statementExp();
				}
				else {
					break _loop306;
				}
				
			} while (true);
			}
			match(CLOSECROCHET);
			unit.getRules().add((simpletrl.Rule)RulesTab.get(CurrentRule));
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
	}
	
	public final java.util.Vector  signRule() throws RecognitionException, TokenStreamException {
		java.util.Vector Parameters=new java.util.Vector();
		
		
		try {      // for error handling
			{
			match(OPENPARENT);
			{
			switch ( LA(1)) {
			case WS:
			case DIEZ:
			{
				Parameters=params();
				break;
			}
			case CLOSEPARENT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(CLOSEPARENT);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		return Parameters;
	}
	
	public final simpletrl.ValueExp  returnclose() throws RecognitionException, TokenStreamException {
		simpletrl.ValueExp vExp=null;
		
		
		try {      // for error handling
			match(LITERAL_return);
			{
			int _cnt327=0;
			_loop327:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					if ( _cnt327>=1 ) { break _loop327; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt327++;
			} while (true);
			}
			{
			int _cnt329=0;
			_loop329:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					vExp=valueExp();
				}
				else {
					if ( _cnt329>=1 ) { break _loop329; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt329++;
			} while (true);
			}
			match(NEWLINE);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_5);
		}
		return vExp;
	}
	
	public final void statementExp() throws RecognitionException, TokenStreamException {
		
		logger.fine("je suis dans Statement");
							  RuleElemVec=new Vector();
							  simpletrl.RuleCallExp rCE;
							  simpletrl.CollectionExp CE;
							  simpletrl.IfStatementExp ifs;
							
		
		try {      // for error handling
			{
			{
			switch ( LA(1)) {
			case NAME:
			case DIEZ:
			case POINTEXCLAM:
			case POINT:
			case LITERAL_allOfType:
			case LITERAL_add:
			case LITERAL_remove:
			case LITERAL_isOfType:
			case LITERAL_equals:
			case INTERO:
			case BOOLEAN:
			case INTEGER:
			case DOUBLE:
			case LITERAL_enum:
			case GUILL:
			{
				{
				context();
				{
				if ((LA(1)==NAME) && (LA(2)==OPENPARENT)) {
					{
					rCE=ruleCallExp();
					}
					
											 
											 if (ifElse.isEmpty())	
											 	((simpletrl.Rule)RulesTab.get(CurrentRule)).getStatements().add(rCE);
											 else	{
											 	if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==1){
											 		iFSE.getThenStatements().add(rCE);
											 	}	
											 	if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==0){
											 		iFSE.getElseStatements().add(rCE);
											 	}
											 }
											 	
										 	
				}
				else if ((LA(1)==NAME) && (LA(2)==EQUAL)) {
					propertyAssignExp();
					value();
					
										 		
										 		if (ifElse.isEmpty()) {	
											 	((simpletrl.Rule)RulesTab.get(CurrentRule)).getStatements().add(pAssExp);
										 		}
											    else	{
										 		if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==1){
											 		iFSE.getThenStatements().add(pAssExp);
											 	}	
											 	if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==0){
											 		iFSE.getElseStatements().add(pAssExp);
											 	}
											 }
					
										 	
				}
				else if ((LA(1)==LITERAL_add||LA(1)==LITERAL_remove)) {
					{
					CE=collectionExp();
					}
					
										 		
										 		if (ifElse.isEmpty())	
											 	((simpletrl.Rule)RulesTab.get(CurrentRule)).getStatements().add(CE);
											    else	{
										 		if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==1){
											 		iFSE.getThenStatements().add(CE);
											 	}	
											 	if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==0){
											 		iFSE.getElseStatements().add(CE);
											 	}
											 }
										 		 
										 	
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				}
				break;
			}
			case LITERAL_if:
			{
				{
				ifs=ifStatementExp();
				}
				
									 		if (ifVect.size()==1){				 								 			
									 			((simpletrl.Rule)RulesTab.get(CurrentRule)).getStatements().add(ifs);
									 			ifElse.clear();
									 			ifVect.clear();
									 		}
									 	
									 		if (ifVect.size()>=2){
									 			
									 			ifElse.removeElementAt(ifElse.size()-1);
									 			ifElse.removeElementAt(ifElse.size()-1);
									 			
									 			if (((Integer)ifElse.get(ifElse.size()-1)).intValue()==0){					 				 
									 		   		((simpletrl.IfStatementExp)ifVect.elementAt(ifVect.size()-2)).getElseStatements().add(ifs);
									 			}
									 		    else {
									 		    	 ((simpletrl.IfStatementExp)ifVect.elementAt(ifVect.size()-2)).getThenStatements().add(ifs);
									 		    }
									 		   
												ifVect.removeElementAt(ifVect.size()-1);
												iFSE=((simpletrl.IfStatementExp)ifVect.elementAt(ifVect.size()-1));					 		  				 		  	
									 		  }					 								 		
									 		
									 		
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			RuleElemVec.removeAllElements();
			match(NEWLINE);
			{
			_loop339:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop339;
				}
				
			} while (true);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
	}
	
	public final java.util.Vector  params() throws RecognitionException, TokenStreamException {
		java.util.Vector Parameters=new java.util.Vector();
		
		simpletrl.ParameterExp p=rulesModel.getParameterExp().createParameterExp();
		
		try {      // for error handling
			{
			{
			_loop313:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop313;
				}
				
			} while (true);
			}
			p=parameterExp();
			{
			_loop315:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop315;
				}
				
			} while (true);
			}
			Parameters.addElement(p);
			{
			_loop319:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					{
					_loop318:
					do {
						if ((LA(1)==WS)) {
							match(WS);
						}
						else {
							break _loop318;
						}
						
					} while (true);
					}
					p=parameterExp();
					Parameters.addElement(p);
				}
				else {
					break _loop319;
				}
				
			} while (true);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_7);
		}
		return Parameters;
	}
	
	public final simpletrl.ParameterExp  parameterExp() throws RecognitionException, TokenStreamException {
		simpletrl.ParameterExp ParamExp=rulesModel.getParameterExp().createParameterExp();
		
		Token  n = null;
		Token  c = null;
		Token  r = null;
		
		try {      // for error handling
			{
			if ((LA(1)==DIEZ) && (LA(2)==NAME)) {
				match(DIEZ);
				n = LT(1);
				match(NAME);
				ParamExp.setName(n.getText());
			}
			else if ((LA(1)==DIEZ) && (LA(2)==LITERAL_context)) {
				match(DIEZ);
				c = LT(1);
				match(LITERAL_context);
				ParamExp.setName(c.getText());
			}
			else if ((LA(1)==DIEZ) && (LA(2)==LITERAL_result)) {
				match(DIEZ);
				r = LT(1);
				match(LITERAL_result);
				ParamExp.setName(r.getText());
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			RuleElemVec.addElement(ParamExp);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return ParamExp;
	}
	
	public final simpletrl.ValueExp  valueExp() throws RecognitionException, TokenStreamException {
		simpletrl.ValueExp ValExp=null;
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case DIEZ:
			{
				{
				ValExp=parameterExp();
				}
				break;
			}
			case LITERAL_allOfType:
			{
				{
				ValExp=modelReferenceExp();
				}
				break;
			}
			case LITERAL_isOfType:
			{
				{
				ValExp=isOfTypeExp();
				}
				break;
			}
			case LITERAL_equals:
			{
				{
				ValExp=compareExp();
				}
				break;
			}
			case INTERO:
			{
				{
				ValExp=ifValueExp();
				}
				break;
			}
			case BOOLEAN:
			case INTEGER:
			case DOUBLE:
			case LITERAL_enum:
			case GUILL:
			{
				{
				ValExp=literalExp();
				}
				break;
			}
			case LITERAL_add:
			case LITERAL_remove:
			{
				{
				ValExp=collectionExp();
				}
				break;
			}
			case POINT:
			{
				match(POINT);
				break;
			}
			default:
				if ((LA(1)==NAME) && (_tokenSet_8.member(LA(2)))) {
					{
					ValExp=propretyCallExp();
					}
				}
				else if ((LA(1)==NAME) && (LA(2)==OPENPARENT)) {
					{
					ValExp=ruleCallExp();
					}
				}
				else if ((LA(1)==NAME) && (LA(2)==EQUAL)) {
					propertyAssignExp();
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return ValExp;
	}
	
	public final void context() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			{
			_loop342:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					valueExp();
				}
				else {
					break _loop342;
				}
				
			} while (true);
			}
			match(POINTEXCLAM);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_9);
		}
	}
	
	public final simpletrl.RuleCallExp  ruleCallExp() throws RecognitionException, TokenStreamException {
		simpletrl.RuleCallExp rCall = rulesModel.getRuleCallExp().createRuleCallExp();
		
		Token  n = null;
		logger.fine("je suis dans ruleCallExp");
							  simpletrl.ValueExp vExp1=null; 
							  simpletrl.ValueExp vExp2=null;
							  Vector paramVec=new Vector();
							  boolean exist;
							
		
		try {      // for error handling
			{
			n = LT(1);
			match(NAME);
			match(OPENPARENT);
			rCall.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
			{
			{
			_loop364:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop364;
				}
				
			} while (true);
			}
			{
			_loop366:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					vExp1=valueExp();
				}
				else {
					break _loop366;
				}
				
			} while (true);
			}
			if (vExp1!=null) paramVec.addElement(vExp1);
			{
			_loop372:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					{
					_loop369:
					do {
						if ((LA(1)==WS)) {
							match(WS);
						}
						else {
							break _loop369;
						}
						
					} while (true);
					}
					{
					_loop371:
					do {
						if ((_tokenSet_4.member(LA(1)))) {
							vExp2=valueExp();
						}
						else {
							break _loop371;
						}
						
					} while (true);
					}
					if (vExp2!=null) paramVec.addElement(vExp2);
				}
				else {
					break _loop372;
				}
				
			} while (true);
			}
			}
			match(CLOSEPARENT);
			}
			exist=(RulesTab.containsKey(n.getText()));
								  	if (!exist){
								  	    simpletrl.CalledRule cr=rulesModel.getCalledRule().createCalledRule(n.getText(),"","");
								  	    RulesTab.put(cr.getName(), cr);
								  	    logger.fine("je suis dans ruleCallExp et le nom de la rgle rajoute est =" + cr.getName()); 
								  	    rCall.setRule(cr);
					       	        		       	        	
								  	}
								  	else {
								  		rCall.setRule((simpletrl.CalledRule)RulesTab.get(n.getText()));		       	        						  		
								  	}
					       	        
					       	        // Correspond  l'association hasArgs du MM 
					       	        for (int i=0; i<paramVec.size(); i++){
					       	        	rCall.getArgs().add((simpletrl.ValueExp)paramVec.elementAt(i));
					       	        }
					       	        
					       	        RuleElemVec.addElement(rCall);
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return rCall;
	}
	
	public final void propertyAssignExp() throws RecognitionException, TokenStreamException {
		
		Token  p = null;
		logger.fine("je suis dans propertyAssignExp");
		
		try {      // for error handling
			p = LT(1);
			match(NAME);
			match(EQUAL);
			pAssExp=rulesModel.getPropertyAssignExp().createPropertyAssignExp(p.getText());
								  pAssExp.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));				 	
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
	}
	
	public final void value() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			{
			_loop451:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					valueExp();
				}
				else {
					break _loop451;
				}
				
			} while (true);
			}
			pAssExp.setValue((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
								  RuleElemVec.addElement(pAssExp);
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
	}
	
	public final simpletrl.CollectionExp  collectionExp() throws RecognitionException, TokenStreamException {
		simpletrl.CollectionExp cE=null;
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_add:
			{
				{
				cE=addCollectionExp();
				}
				break;
			}
			case LITERAL_remove:
			{
				{
				cE=removeCollectionExp();
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return cE;
	}
	
	public final simpletrl.IfStatementExp  ifStatementExp() throws RecognitionException, TokenStreamException {
		simpletrl.IfStatementExp iFPointeur=null;
		
		simpletrl.ValueExp vExp=null;
		
		try {      // for error handling
			match(LITERAL_if);
			{
			_loop434:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop434;
				}
				
			} while (true);
			}
			iFSE=rulesModel.getIfStatementExp().createIfStatementExp();
			match(OPENPARENT);
			{
			int _cnt436=0;
			_loop436:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					vExp=valueExp();
				}
				else {
					if ( _cnt436>=1 ) { break _loop436; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt436++;
			} while (true);
			}
			iFSE.setCond(vExp); 
							 	 ifVect.addElement(iFSE);
							 	
			match(CLOSEPARENT);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case OPENBRACKET:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(OPENBRACKET);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case NAME:
			case CLOSEBRACKET:
			case DIEZ:
			case POINTEXCLAM:
			case POINT:
			case LITERAL_allOfType:
			case LITERAL_add:
			case LITERAL_remove:
			case LITERAL_isOfType:
			case LITERAL_equals:
			case INTERO:
			case LITERAL_if:
			case BOOLEAN:
			case INTEGER:
			case DOUBLE:
			case LITERAL_enum:
			case GUILL:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			ifElse.addElement(new Integer(1));
			{
			_loop440:
			do {
				if ((_tokenSet_3.member(LA(1)))) {
					statementExp();
				}
				else {
					break _loop440;
				}
				
			} while (true);
			}
			match(CLOSEBRACKET);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case LITERAL_else:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LITERAL_else);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case WS:
			case OPENBRACKET:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop444:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop444;
				}
				
			} while (true);
			}
			match(OPENBRACKET);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case NAME:
			case CLOSEBRACKET:
			case DIEZ:
			case POINTEXCLAM:
			case POINT:
			case LITERAL_allOfType:
			case LITERAL_add:
			case LITERAL_remove:
			case LITERAL_isOfType:
			case LITERAL_equals:
			case INTERO:
			case LITERAL_if:
			case BOOLEAN:
			case INTEGER:
			case DOUBLE:
			case LITERAL_enum:
			case GUILL:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			ifElse.addElement(new Integer(0));
			{
			_loop447:
			do {
				if ((_tokenSet_3.member(LA(1)))) {
					statementExp();
				}
				else {
					break _loop447;
				}
				
			} while (true);
			}
			match(CLOSEBRACKET);
			iFPointeur=iFSE;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		return iFPointeur;
	}
	
	public final simpletrl.ModelReferenceExp  modelReferenceExp() throws RecognitionException, TokenStreamException {
		simpletrl.ModelReferenceExp mRef=rulesModel.getModelReferenceExp().createModelReferenceExp();
		
		Token  n = null;
		logger.fine("je suis dans modelReferenceExp");
		
		try {      // for error handling
			{
			match(LITERAL_allOfType);
			match(OPENPARENT);
			{
			_loop357:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop357;
				}
				
			} while (true);
			}
			n = LT(1);
			match(NAME);
			{
			_loop359:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop359;
				}
				
			} while (true);
			}
			match(CLOSEPARENT);
			}
			mRef.setConceptName(n.getText());
								  RuleElemVec.addElement(mRef);
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return mRef;
	}
	
	public final simpletrl.PropertyCallExp  propretyCallExp() throws RecognitionException, TokenStreamException {
		simpletrl.PropertyCallExp pCallExp=null;
		
		Token  n = null;
		
		try {      // for error handling
			n = LT(1);
			match(NAME);
			
								 logger.fine("je suis dans propertyCallExp et PCE=" + n.getText());
								 pCallExp = rulesModel.getPropertyCallExp().createPropertyCallExp(n.getText());
								 pCallExp.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
								 RuleElemVec.addElement(pCallExp);
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return pCallExp;
	}
	
	public final simpletrl.IsOfTypeExp  isOfTypeExp() throws RecognitionException, TokenStreamException {
		simpletrl.IsOfTypeExp isOT=rulesModel.getIsOfTypeExp().createIsOfTypeExp();
		
		Token  t = null;
		logger.fine("je suis dans isOfTypeExp");
		
		try {      // for error handling
			{
			match(LITERAL_isOfType);
			match(OPENPARENT);
			{
			_loop397:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop397;
				}
				
			} while (true);
			}
			t = LT(1);
			match(NAME);
			{
			_loop399:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop399;
				}
				
			} while (true);
			}
			match(CLOSEPARENT);
			}
			isOT.setType(t.getText());
								  isOT.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
								  RuleElemVec.addElement(isOT);
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return isOT;
	}
	
	public final simpletrl.CompareExp  compareExp() throws RecognitionException, TokenStreamException {
		simpletrl.CompareExp CompExp=rulesModel.getCompareExp().createCompareExp();
		
		logger.fine("je suis dans compareExp");
					     	 simpletrl.ValueExp ValExPointeur=null;
					     	
		
		try {      // for error handling
			{
			match(LITERAL_equals);
			match(OPENPARENT);
			{
			_loop403:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop403;
				}
				
			} while (true);
			}
			CompExp.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
			{
			int _cnt405=0;
			_loop405:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					ValExPointeur=valueExp();
				}
				else {
					if ( _cnt405>=1 ) { break _loop405; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt405++;
			} while (true);
			}
			{
			_loop407:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop407;
				}
				
			} while (true);
			}
			match(CLOSEPARENT);
			}
			
							     	// Correspond  l'association compareVal du MM
							     	CompExp.setCompareVal(ValExPointeur);
							     	RuleElemVec.addElement(CompExp);
							
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return CompExp;
	}
	
	public final simpletrl.IfValueExp  ifValueExp() throws RecognitionException, TokenStreamException {
		simpletrl.IfValueExp ifValExp=rulesModel.getIfValueExp().createIfValueExp();
		
		logger.fine("je suis dans ifValueExp");
					    	 simpletrl.ValueExp condValExp=null;
					    	 simpletrl.ValueExp thenValExp=null;
					    	 simpletrl.ValueExp elseValExp=null;
					    	
		
		try {      // for error handling
			match(INTERO);
			match(OPENPARENT);
			{
			int _cnt410=0;
			_loop410:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					condValExp=valueExp();
				}
				else {
					if ( _cnt410>=1 ) { break _loop410; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt410++;
			} while (true);
			}
			ifValExp.setCond(condValExp);
			match(CLOSEPARENT);
			match(INTERO);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case WS:
			case OPENBRACKET:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop413:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop413;
				}
				
			} while (true);
			}
			match(OPENBRACKET);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case WS:
			case NAME:
			case DIEZ:
			case POINT:
			case LITERAL_allOfType:
			case LITERAL_add:
			case LITERAL_remove:
			case LITERAL_isOfType:
			case LITERAL_equals:
			case INTERO:
			case BOOLEAN:
			case INTEGER:
			case DOUBLE:
			case LITERAL_enum:
			case GUILL:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop416:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop416;
				}
				
			} while (true);
			}
			{
			int _cnt418=0;
			_loop418:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					thenValExp=valueExp();
				}
				else {
					if ( _cnt418>=1 ) { break _loop418; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt418++;
			} while (true);
			}
			ifValExp.setThenExp(thenValExp);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case WS:
			case CLOSEBRACKET:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop421:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop421;
				}
				
			} while (true);
			}
			match(CLOSEBRACKET);
			{
			_loop423:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop423;
				}
				
			} while (true);
			}
			match(TOWPOINT);
			{
			_loop425:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop425;
				}
				
			} while (true);
			}
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case OPENBRACKET:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(OPENBRACKET);
			{
			_loop428:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					elseValExp=valueExp();
				}
				else {
					break _loop428;
				}
				
			} while (true);
			}
			ifValExp.setElseExp(elseValExp);
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case WS:
			case CLOSEBRACKET:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop431:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop431;
				}
				
			} while (true);
			}
			match(CLOSEBRACKET);
			RuleElemVec.addElement(ifValExp);	
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return ifValExp;
	}
	
	public final simpletrl.LiteralExp  literalExp() throws RecognitionException, TokenStreamException {
		simpletrl.LiteralExp litExp=null;
		
		Token  bool = null;
		Token  integer = null;
		Token  doubleL = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case BOOLEAN:
			{
				bool = LT(1);
				match(BOOLEAN);
				boolean trueOfalse; 
									 	if (bool.getText().equalsIgnoreCase("1T"))     
									 		trueOfalse=true;
									 	else
									 		trueOfalse=false;
									 		
									 	litExp=rulesModel.getBooleanLiteral().createBooleanLiteral(trueOfalse);
				break;
			}
			case INTEGER:
			{
				{
				integer = LT(1);
				match(INTEGER);
				}
				litExp=rulesModel.getIntegerLiteral().createIntegerLiteral(Integer.parseInt(integer.getText()));
				break;
			}
			case LITERAL_enum:
			{
				{
				litExp=enumExp();
				}
				break;
			}
			case GUILL:
			{
				{
				litExp=string();
				}
				break;
			}
			case DOUBLE:
			{
				{
				doubleL = LT(1);
				match(DOUBLE);
				}
				litExp=rulesModel.getDoubleLiteral().createDoubleLiteral(Double.parseDouble(doubleL.getText()));
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if(litExp!=null) RuleElemVec.addElement(litExp);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return litExp;
	}
	
	public final simpletrl.AddCollectionExp  addCollectionExp() throws RecognitionException, TokenStreamException {
		simpletrl.AddCollectionExp aCE=rulesModel.getAddCollectionExp().createAddCollectionExp();
		
		simpletrl.ValueExp member=null;
		
		try {      // for error handling
			{
			match(LITERAL_add);
			match(OPENPARENT);
			{
			_loop380:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop380;
				}
				
			} while (true);
			}
			aCE.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
			{
			int _cnt382=0;
			_loop382:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					member=valueExp();
				}
				else {
					if ( _cnt382>=1 ) { break _loop382; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt382++;
			} while (true);
			}
			{
			_loop384:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop384;
				}
				
			} while (true);
			}
			match(CLOSEPARENT);
			}
			aCE.setMember(member);	
								  RuleElemVec.addElement(aCE);	
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return aCE;
	}
	
	public final simpletrl.RemoveCollectionExp  removeCollectionExp() throws RecognitionException, TokenStreamException {
		simpletrl.RemoveCollectionExp rCE=rulesModel.getRemoveCollectionExp().createRemoveCollectionExp();
		
		simpletrl.ValueExp member=null;
		
		try {      // for error handling
			{
			match(LITERAL_remove);
			match(OPENPARENT);
			{
			_loop388:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop388;
				}
				
			} while (true);
			}
			rCE.setContext((simpletrl.ValueExp)RuleElemVec.elementAt(RuleElemVec.size()-1));
			{
			int _cnt390=0;
			_loop390:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					member=valueExp();
				}
				else {
					if ( _cnt390>=1 ) { break _loop390; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt390++;
			} while (true);
			}
			{
			_loop392:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop392;
				}
				
			} while (true);
			}
			match(CLOSEPARENT);
			}
			rCE.setMember(member);	
								  RuleElemVec.addElement(rCE);	
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return rCE;
	}
	
	public final simpletrl.EnumLiteral  enumExp() throws RecognitionException, TokenStreamException {
		simpletrl.EnumLiteral enumLit=null;
		
		Token  val = null;
		Token  srcOtrg = null;
		Token  type = null;
		
		try {      // for error handling
			match(LITERAL_enum);
			{
			_loop460:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop460;
				}
				
			} while (true);
			}
			match(OPENPARENT);
			{
			_loop462:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop462;
				}
				
			} while (true);
			}
			val = LT(1);
			match(NAME);
			{
			_loop464:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop464;
				}
				
			} while (true);
			}
			match(TOWPOINT);
			{
			_loop466:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop466;
				}
				
			} while (true);
			}
			srcOtrg = LT(1);
			match(NAME);
			{
			_loop468:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop468;
				}
				
			} while (true);
			}
			match(COMMA);
			{
			_loop470:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop470;
				}
				
			} while (true);
			}
			type = LT(1);
			match(NAME);
			{
			_loop472:
			do {
				if ((LA(1)==WS)) {
					match(WS);
				}
				else {
					break _loop472;
				}
				
			} while (true);
			}
			match(CLOSEPARENT);
			boolean sOt;
								 	if (srcOtrg.getText().equalsIgnoreCase("src"))
								 		sOt=true;
								 	else
								 		sOt=false;
								 	enumLit=rulesModel.getEnumLiteral().createEnumLiteral(val.getText(),type.getText(),sOt);
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return enumLit;
	}
	
	public final simpletrl.StringLiteral  string() throws RecognitionException, TokenStreamException {
		simpletrl.StringLiteral stringLit=null;
		
		Token  String = null;
		
		try {      // for error handling
			match(GUILL);
			String = LT(1);
			match(NAME);
			match(GUILL);
			stringLit=rulesModel.getStringLiteral().createStringLiteral(String.getText());
								
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return stringLit;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"RulesUnit\"",
		"WS",
		"NAME",
		"SOURCE",
		"TARGET",
		"OPENBRACKET",
		"NEWLINE",
		"CLOSEBRACKET",
		"\"EntryPointRule\"",
		"\"context\"",
		"\"Rule\"",
		"OPENCROCHET",
		"CLOSECROCHET",
		"OPENPARENT",
		"CLOSEPARENT",
		"COMMA",
		"DIEZ",
		"\"result\"",
		"\"creates\"",
		"\"return\"",
		"POINTEXCLAM",
		"POINT",
		"\"allOfType\"",
		"\"add\"",
		"\"remove\"",
		"\"isOfType\"",
		"\"equals\"",
		"INTERO",
		"TOWPOINT",
		"\"if\"",
		"\"else\"",
		"EQUAL",
		"BOOLEAN",
		"INTEGER",
		"DOUBLE",
		"\"enum\"",
		"GUILL"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 1024L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 8422432L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 2143172952128L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 2134566240320L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 33792L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 2143173019712L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 262144L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 2134583807072L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 402653248L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	
	}
