/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

// le Code gnr du Pckage: ModelPackage
package org.omg.mof.Model ;
public class ModelPackageImpl extends org.omg.mof.Model._ModelPackagePOA {
		//Ajout de la partie RefBaseObject 
		// Operation ref_mof_id
		  public java.lang.String ref_mof_id(){
		    int id = _orb().object_to_string(_this()).hashCode();
		     return String.valueOf(id);
		  }
		  // Operation ref_meta_object
		  public org.omg.mof.Reflective.RefObject ref_meta_object(){
		    throw new org.omg.CORBA.NO_IMPLEMENT("ref_meta_object method not implemented",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		    }
		 // Operation ref_itself
		 public boolean ref_itself(org.omg.mof.Reflective.RefBaseObject other_object){
		     String id_obj = other_object.ref_mof_id();
		     if (ref_mof_id().equals(id_obj)) return true;
		     else return false;
		  }
		 // Operation ref_immediate_package
		 public org.omg.mof.Reflective._RefPackage ref_immediate_package(){
		    throw new org.omg.CORBA.NO_IMPLEMENT("ref_immediate_package method not implemented",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		 }
		 // Operation ref_outermost_package
		 public org.omg.mof.Reflective._RefPackage ref_outermost_package(){
		 throw new org.omg.CORBA.NO_IMPLEMENT("ref_moutermost_package method not implemented",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		  }
		  // Operation ref_delete
		 public void ref_delete() throws org.omg.mof.Reflective.MofError {
		  throw new org.omg.CORBA.NO_IMPLEMENT("ref_delete method not implemented",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		  }

		 // Operation ref_class_ref
		 public org.omg.mof.Reflective.RefObject ref_class_ref(org.omg.mof.Reflective.RefObject _class)
		  throws org.omg.mof.Reflective.MofError{
		  throw new org.omg.CORBA.NO_IMPLEMENT("ref_class_ref method not implemented",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		  }
		 // Operation ref_association_ref
		 public org.omg.mof.Reflective.RefAssociation ref_association_ref(org.omg.mof.Reflective.RefObject association)
		  throws org.omg.mof.Reflective.MofError {
		  throw new org.omg.CORBA.NO_IMPLEMENT("ref_association_ref method not implemented",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		  }
		 // Operation ref_package_ref
		 public org.omg.mof.Reflective._RefPackage ref_package_ref(org.omg.mof.Reflective.RefObject _package)
		  throws org.omg.mof.Reflective.MofError{
		  throw new org.omg.CORBA.NO_IMPLEMENT("ref_package_ref method not implemented",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		  }
	private org.omg.mof.Model.ModelElementClass  _model_element_ref = null ;
	public org.omg.mof.Model.ModelElementClass model_element_ref(){
	 if( _model_element_ref == null ) {
		org.omg.mof.Model.ModelElementClassImpl  _model_element_temp = new org.omg.mof.Model.ModelElementClassImpl(_this());
		try {
		_poa().activate_object(_model_element_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_model_element_temp);
		_model_element_ref = org.omg.mof.Model.ModelElementClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _model_element_ref;
		}
	private org.omg.mof.Model.ImportClass  _import_ref = null ;
	public org.omg.mof.Model.ImportClass import_ref(){
	 if( _import_ref == null ) {
		org.omg.mof.Model.ImportClassImpl  _import_temp = new org.omg.mof.Model.ImportClassImpl(_this());
		try {
		_poa().activate_object(_import_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_import_temp);
		_import_ref = org.omg.mof.Model.ImportClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _import_ref;
		}
	private org.omg.mof.Model.NamespaceClass  _namespace_ref = null ;
	public org.omg.mof.Model.NamespaceClass namespace_ref(){
	 if( _namespace_ref == null ) {
		org.omg.mof.Model.NamespaceClassImpl  _namespace_temp = new org.omg.mof.Model.NamespaceClassImpl(_this());
		try {
		_poa().activate_object(_namespace_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_namespace_temp);
		_namespace_ref = org.omg.mof.Model.NamespaceClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _namespace_ref;
		}
	private org.omg.mof.Model.ConstraintClass  _constraint_ref = null ;
	public org.omg.mof.Model.ConstraintClass constraint_ref(){
	 if( _constraint_ref == null ) {
		org.omg.mof.Model.ConstraintClassImpl  _constraint_temp = new org.omg.mof.Model.ConstraintClassImpl(_this());
		try {
		_poa().activate_object(_constraint_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_constraint_temp);
		_constraint_ref = org.omg.mof.Model.ConstraintClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _constraint_ref;
		}
	private org.omg.mof.Model.TagClass  _tag_ref = null ;
	public org.omg.mof.Model.TagClass tag_ref(){
	 if( _tag_ref == null ) {
		org.omg.mof.Model.TagClassImpl  _tag_temp = new org.omg.mof.Model.TagClassImpl(_this());
		try {
		_poa().activate_object(_tag_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_tag_temp);
		_tag_ref = org.omg.mof.Model.TagClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _tag_ref;
		}
	private org.omg.mof.Model.TypedElementClass  _typed_element_ref = null ;
	public org.omg.mof.Model.TypedElementClass typed_element_ref(){
	 if( _typed_element_ref == null ) {
		org.omg.mof.Model.TypedElementClassImpl  _typed_element_temp = new org.omg.mof.Model.TypedElementClassImpl(_this());
		try {
		_poa().activate_object(_typed_element_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_typed_element_temp);
		_typed_element_ref = org.omg.mof.Model.TypedElementClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _typed_element_ref;
		}
	private org.omg.mof.Model.GeneralizableElementClass  _generalizable_element_ref = null ;
	public org.omg.mof.Model.GeneralizableElementClass generalizable_element_ref(){
	 if( _generalizable_element_ref == null ) {
		org.omg.mof.Model.GeneralizableElementClassImpl  _generalizable_element_temp = new org.omg.mof.Model.GeneralizableElementClassImpl(_this());
		try {
		_poa().activate_object(_generalizable_element_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_generalizable_element_temp);
		_generalizable_element_ref = org.omg.mof.Model.GeneralizableElementClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _generalizable_element_ref;
		}
	private org.omg.mof.Model.FeatureClass  _feature_ref = null ;
	public org.omg.mof.Model.FeatureClass feature_ref(){
	 if( _feature_ref == null ) {
		org.omg.mof.Model.FeatureClassImpl  _feature_temp = new org.omg.mof.Model.FeatureClassImpl(_this());
		try {
		_poa().activate_object(_feature_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_feature_temp);
		_feature_ref = org.omg.mof.Model.FeatureClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _feature_ref;
		}
	private org.omg.mof.Model.TypeAliasClass  _type_alias_ref = null ;
	public org.omg.mof.Model.TypeAliasClass type_alias_ref(){
	 if( _type_alias_ref == null ) {
		org.omg.mof.Model.TypeAliasClassImpl  _type_alias_temp = new org.omg.mof.Model.TypeAliasClassImpl(_this());
		try {
		_poa().activate_object(_type_alias_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_type_alias_temp);
		_type_alias_ref = org.omg.mof.Model.TypeAliasClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _type_alias_ref;
		}
	private org.omg.mof.Model.ParameterClass  _parameter_ref = null ;
	public org.omg.mof.Model.ParameterClass parameter_ref(){
	 if( _parameter_ref == null ) {
		org.omg.mof.Model.ParameterClassImpl  _parameter_temp = new org.omg.mof.Model.ParameterClassImpl(_this());
		try {
		_poa().activate_object(_parameter_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_parameter_temp);
		_parameter_ref = org.omg.mof.Model.ParameterClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _parameter_ref;
		}
	private org.omg.mof.Model.ConstantClass  _constant_ref = null ;
	public org.omg.mof.Model.ConstantClass constant_ref(){
	 if( _constant_ref == null ) {
		org.omg.mof.Model.ConstantClassImpl  _constant_temp = new org.omg.mof.Model.ConstantClassImpl(_this());
		try {
		_poa().activate_object(_constant_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_constant_temp);
		_constant_ref = org.omg.mof.Model.ConstantClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _constant_ref;
		}
	private org.omg.mof.Model.StructuralFeatureClass  _structural_feature_ref = null ;
	public org.omg.mof.Model.StructuralFeatureClass structural_feature_ref(){
	 if( _structural_feature_ref == null ) {
		org.omg.mof.Model.StructuralFeatureClassImpl  _structural_feature_temp = new org.omg.mof.Model.StructuralFeatureClassImpl(_this());
		try {
		_poa().activate_object(_structural_feature_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_structural_feature_temp);
		_structural_feature_ref = org.omg.mof.Model.StructuralFeatureClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _structural_feature_ref;
		}
	private org.omg.mof.Model.BehavioralFeatureClass  _behavioral_feature_ref = null ;
	public org.omg.mof.Model.BehavioralFeatureClass behavioral_feature_ref(){
	 if( _behavioral_feature_ref == null ) {
		org.omg.mof.Model.BehavioralFeatureClassImpl  _behavioral_feature_temp = new org.omg.mof.Model.BehavioralFeatureClassImpl(_this());
		try {
		_poa().activate_object(_behavioral_feature_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_behavioral_feature_temp);
		_behavioral_feature_ref = org.omg.mof.Model.BehavioralFeatureClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _behavioral_feature_ref;
		}
	private org.omg.mof.Model.ClassifierClass  _classifier_ref = null ;
	public org.omg.mof.Model.ClassifierClass classifier_ref(){
	 if( _classifier_ref == null ) {
		org.omg.mof.Model.ClassifierClassImpl  _classifier_temp = new org.omg.mof.Model.ClassifierClassImpl(_this());
		try {
		_poa().activate_object(_classifier_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_classifier_temp);
		_classifier_ref = org.omg.mof.Model.ClassifierClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _classifier_ref;
		}
	private org.omg.mof.Model.PackageClass  _package_ref = null ;
	public org.omg.mof.Model.PackageClass package_ref(){
	 if( _package_ref == null ) {
		org.omg.mof.Model.PackageClassImpl  _package_temp = new org.omg.mof.Model.PackageClassImpl(_this());
		try {
		_poa().activate_object(_package_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_package_temp);
		_package_ref = org.omg.mof.Model.PackageClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _package_ref;
		}
	private org.omg.mof.Model.AssociationEndClass  _association_end_ref = null ;
	public org.omg.mof.Model.AssociationEndClass association_end_ref(){
	 if( _association_end_ref == null ) {
		org.omg.mof.Model.AssociationEndClassImpl  _association_end_temp = new org.omg.mof.Model.AssociationEndClassImpl(_this());
		try {
		_poa().activate_object(_association_end_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_association_end_temp);
		_association_end_ref = org.omg.mof.Model.AssociationEndClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _association_end_ref;
		}
	private org.omg.mof.Model.ReferenceClass  _reference_ref = null ;
	public org.omg.mof.Model.ReferenceClass reference_ref(){
	 if( _reference_ref == null ) {
		org.omg.mof.Model.ReferenceClassImpl  _reference_temp = new org.omg.mof.Model.ReferenceClassImpl(_this());
		try {
		_poa().activate_object(_reference_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_reference_temp);
		_reference_ref = org.omg.mof.Model.ReferenceClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _reference_ref;
		}
	private org.omg.mof.Model.MofAttributeClass  _mof_attribute_ref = null ;
	public org.omg.mof.Model.MofAttributeClass mof_attribute_ref(){
	 if( _mof_attribute_ref == null ) {
		org.omg.mof.Model.MofAttributeClassImpl  _mof_attribute_temp = new org.omg.mof.Model.MofAttributeClassImpl(_this());
		try {
		_poa().activate_object(_mof_attribute_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_mof_attribute_temp);
		_mof_attribute_ref = org.omg.mof.Model.MofAttributeClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _mof_attribute_ref;
		}
	private org.omg.mof.Model.MofExceptionClass  _mof_exception_ref = null ;
	public org.omg.mof.Model.MofExceptionClass mof_exception_ref(){
	 if( _mof_exception_ref == null ) {
		org.omg.mof.Model.MofExceptionClassImpl  _mof_exception_temp = new org.omg.mof.Model.MofExceptionClassImpl(_this());
		try {
		_poa().activate_object(_mof_exception_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_mof_exception_temp);
		_mof_exception_ref = org.omg.mof.Model.MofExceptionClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _mof_exception_ref;
		}
	private org.omg.mof.Model.OperationClass  _operation_ref = null ;
	public org.omg.mof.Model.OperationClass operation_ref(){
	 if( _operation_ref == null ) {
		org.omg.mof.Model.OperationClassImpl  _operation_temp = new org.omg.mof.Model.OperationClassImpl(_this());
		try {
		_poa().activate_object(_operation_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_operation_temp);
		_operation_ref = org.omg.mof.Model.OperationClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _operation_ref;
		}
	private org.omg.mof.Model.ClassClass  _class_ref = null ;
	public org.omg.mof.Model.ClassClass class_ref(){
	 if( _class_ref == null ) {
		org.omg.mof.Model.ClassClassImpl  _class_temp = new org.omg.mof.Model.ClassClassImpl(_this());
		try {
		_poa().activate_object(_class_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_class_temp);
		_class_ref = org.omg.mof.Model.ClassClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _class_ref;
		}
	private org.omg.mof.Model.DataTypeClass  _data_type_ref = null ;
	public org.omg.mof.Model.DataTypeClass data_type_ref(){
	 if( _data_type_ref == null ) {
		org.omg.mof.Model.DataTypeClassImpl  _data_type_temp = new org.omg.mof.Model.DataTypeClassImpl(_this());
		try {
		_poa().activate_object(_data_type_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_data_type_temp);
		_data_type_ref = org.omg.mof.Model.DataTypeClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _data_type_ref;
		}
	private org.omg.mof.Model.AssociationClass  _association_ref = null ;
	public org.omg.mof.Model.AssociationClass association_ref(){
	 if( _association_ref == null ) {
		org.omg.mof.Model.AssociationClassImpl  _association_temp = new org.omg.mof.Model.AssociationClassImpl(_this());
		try {
		_poa().activate_object(_association_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_association_temp);
		_association_ref = org.omg.mof.Model.AssociationClassHelper.narrow(obj);
			}
		catch (java.lang.Exception ex) {
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _association_ref;
		}
	private org.omg.mof.Model.DependsOn  _depends_on_ref = null ;
	public org.omg.mof.Model.DependsOn depends_on_ref(){
	 if( _depends_on_ref == null ) {
		org.omg.mof.Model.DependsOnImpl _depends_on_temp = new org.omg.mof.Model.DependsOnImpl();
		try {
		_poa().activate_object(_depends_on_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_depends_on_temp);
		_depends_on_ref = org.omg.mof.Model.DependsOnHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _depends_on_ref ;
		}
	private org.omg.mof.Model.Contains  _contains_ref = null ;
	public org.omg.mof.Model.Contains contains_ref(){
	 if( _contains_ref == null ) {
		org.omg.mof.Model.ContainsImpl _contains_temp = new org.omg.mof.Model.ContainsImpl();
		try {
		_poa().activate_object(_contains_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_contains_temp);
		_contains_ref = org.omg.mof.Model.ContainsHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _contains_ref ;
		}
	private org.omg.mof.Model.AttachesTo  _attaches_to_ref = null ;
	public org.omg.mof.Model.AttachesTo attaches_to_ref(){
	 if( _attaches_to_ref == null ) {
		org.omg.mof.Model.AttachesToImpl _attaches_to_temp = new org.omg.mof.Model.AttachesToImpl();
		try {
		_poa().activate_object(_attaches_to_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_attaches_to_temp);
		_attaches_to_ref = org.omg.mof.Model.AttachesToHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _attaches_to_ref ;
		}
	private org.omg.mof.Model.Constrains  _constrains_ref = null ;
	public org.omg.mof.Model.Constrains constrains_ref(){
	 if( _constrains_ref == null ) {
		org.omg.mof.Model.ConstrainsImpl _constrains_temp = new org.omg.mof.Model.ConstrainsImpl();
		try {
		_poa().activate_object(_constrains_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_constrains_temp);
		_constrains_ref = org.omg.mof.Model.ConstrainsHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _constrains_ref ;
		}
	private org.omg.mof.Model.Aliases  _aliases_ref = null ;
	public org.omg.mof.Model.Aliases aliases_ref(){
	 if( _aliases_ref == null ) {
		org.omg.mof.Model.AliasesImpl _aliases_temp = new org.omg.mof.Model.AliasesImpl();
		try {
		_poa().activate_object(_aliases_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_aliases_temp);
		_aliases_ref = org.omg.mof.Model.AliasesHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _aliases_ref ;
		}
	private org.omg.mof.Model.Generalizes  _generalizes_ref = null ;
	public org.omg.mof.Model.Generalizes generalizes_ref(){
	 if( _generalizes_ref == null ) {
		org.omg.mof.Model.GeneralizesImpl _generalizes_temp = new org.omg.mof.Model.GeneralizesImpl();
		try {
		_poa().activate_object(_generalizes_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_generalizes_temp);
		_generalizes_ref = org.omg.mof.Model.GeneralizesHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _generalizes_ref ;
		}
	private org.omg.mof.Model.IsOfType  _is_of_type_ref = null ;
	public org.omg.mof.Model.IsOfType is_of_type_ref(){
	 if( _is_of_type_ref == null ) {
		org.omg.mof.Model.IsOfTypeImpl _is_of_type_temp = new org.omg.mof.Model.IsOfTypeImpl();
		try {
		_poa().activate_object(_is_of_type_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_is_of_type_temp);
		_is_of_type_ref = org.omg.mof.Model.IsOfTypeHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _is_of_type_ref ;
		}
	private org.omg.mof.Model.CanRaise  _can_raise_ref = null ;
	public org.omg.mof.Model.CanRaise can_raise_ref(){
	 if( _can_raise_ref == null ) {
		org.omg.mof.Model.CanRaiseImpl _can_raise_temp = new org.omg.mof.Model.CanRaiseImpl();
		try {
		_poa().activate_object(_can_raise_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_can_raise_temp);
		_can_raise_ref = org.omg.mof.Model.CanRaiseHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _can_raise_ref ;
		}
	private org.omg.mof.Model.RefersTo  _refers_to_ref = null ;
	public org.omg.mof.Model.RefersTo refers_to_ref(){
	 if( _refers_to_ref == null ) {
		org.omg.mof.Model.RefersToImpl _refers_to_temp = new org.omg.mof.Model.RefersToImpl();
		try {
		_poa().activate_object(_refers_to_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_refers_to_temp);
		_refers_to_ref = org.omg.mof.Model.RefersToHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _refers_to_ref ;
		}
	private org.omg.mof.Model.Exposes  _exposes_ref = null ;
	public org.omg.mof.Model.Exposes exposes_ref(){
	 if( _exposes_ref == null ) {
		org.omg.mof.Model.ExposesImpl _exposes_temp = new org.omg.mof.Model.ExposesImpl();
		try {
		_poa().activate_object(_exposes_temp);
		org.omg.CORBA.Object obj = _poa().servant_to_reference(_exposes_temp);
		_exposes_ref = org.omg.mof.Model.ExposesHelper.narrow(obj);
			}
		catch (java.lang.Exception ex){
		ex.printStackTrace();
		System.exit(0);
			}
		}
		return _exposes_ref ;
		}
	public ModelPackageImpl() {
	} 
}
