package org.objectweb.modfact.jmi.reflect;

import javax.jmi.reflect.*;
import java.util.*;

public abstract class RefBaseObjectImpl 
		
		extends ReflectHelper
		implements javax.jmi.reflect.RefBaseObject, java.io.Serializable {
    
    static RefPackageImpl m3 = null;
    
    RefObjectImpl metaObject = null;
    RefPackageImpl container = null;
    String name = null;
    
    public RefBaseObjectImpl() {
    }
    
    public String refMofId() {
        return String.valueOf(this.hashCode());
    }
    
    public javax.jmi.reflect.RefPackage refOutermostPackage() {
        Object r = this;
        RefPackage p = this.refImmediatePackage(); 
        while(p!=null) {
            r = p;
            p = p.refImmediatePackage(); 
        }
        return (RefPackage)r;
    }
 
    public javax.jmi.reflect.RefPackage refImmediatePackage() {
        return container;
    }    
    
    public java.util.Collection refVerifyConstraints(boolean param) {
        throw new RuntimeException("No implementation: refVerifyConstraints");
    }
    
    // helper methods
   
    public List refTypeName() {
        List typeName;
        RefBaseObjectImpl p = (RefBaseObjectImpl)refImmediatePackage();
        typeName = (p==null)? new Vector() : p.refTypeName();
        typeName.add( name );
        return typeName;
    }
    
    
    boolean isM3() {
      return refOutermostPackage()==m3;
    }
    
    
    public String toString() {
        String className = this.getClass().getName();
        String type = className.substring(className.lastIndexOf(".")+1 ,className.length())  // no package prefix        
            +refTypeName().toString();
        return type;            
    }
    

//	//lookup for contained RefClass, RefPackage, RefAssociation
//	
//	RefBaseObject resolveQualifiedNameInExtent(List qName) {
//	  return ReflectHelper.resolveQualifiedNameInExtent(this, qName);
//	}
    
}
