package org.objectweb.modfact.jmi.xmi;

import java.util.*;

public class CharTranslator {

	Collection set = new Vector(); 
	
	public CharTranslator() {
		set.add(new TranslationEntry("<","&lt;"));
		set.add(new TranslationEntry(">","&gt;"));		
	}
	
	
	public String encode(String s) {
		Iterator it = set.iterator();
		while(it.hasNext()) {
			TranslationEntry entry = (TranslationEntry) it.next();
			s = replaceAll(s, entry.view ,entry.encode);
		}
		return s;		
	}
		
	public String view(String s) {
		Iterator it = set.iterator();
		while(it.hasNext()) {
			TranslationEntry entry = (TranslationEntry) it.next();
			s = replaceAll(s, entry.encode ,entry.view);
		}
		return s;		
	}
	
	
	public static String replaceAll(String in, String replace, String by) {
		int i;
		while((i=in.indexOf(replace))>=0) {
		  in = in.substring(0, i) 
		  	+ by 
		  	+ in.substring(i + replace.length());
		}
		return in;  
	}
	
	
	static class TranslationEntry {
		String view; 
		String encode;	
		TranslationEntry(String v, String en) {	
		  view = v;
		  encode = en;
		}
	}
	
}
